#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int k,min_cost = 1000000, max_nut = 0;
int recommendations[4], ingredients[50][5], visited[50] = {0,}, nutritions[4] = {0,};
vector< pair<int,int> > foodInfo;
vector<int> foodList, cur_list;

bool dfs(int index, int total_cost, int total_nut) {

    if(total_cost > min_cost) return true;

    bool flag = true;
    for(int i=0; i<4; i++) {
        if(nutritions[i]<recommendations[i]) {
            flag = false;
            break;
        }
    }
    if(flag) {
        if(total_cost < min_cost) {
            min_cost = total_cost;
            foodList = cur_list;
            max_nut = total_nut;
        }
        else if(total_cost == min_cost) {
            if(total_nut > max_nut) {
                foodList = cur_list;
                max_nut = total_nut;
            }
        }
        return true;
    }
    
    for(int i=index; i<k; i++) {
        int cost = foodInfo[i].first;
        int food = foodInfo[i].second;

        if(visited[food]) continue;

        visited[food] = 1;
        for(int j=0; j<4; j++) 
            nutritions[j] += ingredients[food][j];
        cur_list.push_back(food);

        bool flag = dfs(i, total_cost+cost, total_nut+ingredients[food][4]);
        if(i != k-1 && flag) flag = cost!=foodInfo[i+1].first;

        cur_list.pop_back();
        for(int j=0; j<4; j++) 
            nutritions[j] -= ingredients[food][j];
        visited[food] = 0;

        if(flag) break;
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    int total[4] = {0,};
    cin >> k;
    for(int i=0; i<4; i++) cin >> recommendations[i];

    for(int i=0; i<k; i++) {
        int p,f,s,v,c;
        cin >> p >> f >> s >> v >> c;
        ingredients[i][0] = p;
        ingredients[i][1] = f;
        ingredients[i][2] = s;
        ingredients[i][3] = v;
        ingredients[i][4] = p+f+s+v;
        foodInfo.push_back(pair<int,int>(c,i));
    }
    sort(foodInfo.begin(), foodInfo.end());

    for(int i=0; i<k; i++) 
        for(int j=0; j<4; j++) 
            total[j] += ingredients[i][j];
    
    bool flag = false;
    for(int i=0; i<4; i++) 
        if(total[i]<recommendations[i]) flag = true;
    if(flag) {
        cout << 0;
        return 0;
    }

    dfs(0,0,0);

    sort(foodList.begin(), foodList.end());
    for(int i=0; i<foodList.size(); i++) 
        cout << foodList[i]+1 << " ";

    return 0;
}