#include <bits/stdc++.h>

using namespace std;

void greedy();
void backtracking(int index);

int ingred[50][5]; // protein, fat, carbohydrate, vitamin, price
int recommended[4]; // protein, fat, carbohydrate, vitamin
int best_price, best_sum = 0;
vector<int> best_selected;
vector<int> selected;
int n, price = 0, nutrients[4] = {0, 0, 0,0};
int min_price[51], sums[51][4];
priority_queue<pair<float, int>, vector<pair<float, int>>, greater<pair<float,int>>> pq;

int main() {
    cin >> n;
    cin >> recommended[0] >> recommended[1] >> recommended[2] >> recommended[3];
    for(int i=0; i<n; i++){
        cin >> ingred[i][0] >> ingred[i][1] >>ingred[i][2] >>ingred[i][3] >> ingred[i][4];
        pq.push(make_pair((float)ingred[i][4] / (ingred[i][0] + ingred[i][1] + ingred[i][2] + ingred[i][3]), i));
    }
    min_price[n-1] = ingred[n-1][4];
    sums[n][0] = 0; sums[n][1] = 0; sums[n][2] = 0; sums[n][3] = 0;
    sums[n-1][0] = ingred[n-1][0]; sums[n-1][1] = ingred[n-1][1];
    sums[n-1][2] = ingred[n-1][2]; sums[n-1][3] = ingred[n-1][3];
    for(int i=n-2; i>=0; i--){
        min_price[i] = min(min_price[i+1], ingred[i][4]);
        for(int j=0; j<4; j++){
            sums[i][j] = ingred[i][j] + sums[i+1][j];
        }
    }
    greedy();
    if(best_sum == 0){
        cout << 0;
        return 0;
    }
    backtracking(0);
    for(auto k : best_selected){
        cout << k+1 << " ";
    }
}

void greedy(){
    int nutrients[4] = {0, 0, 0,0};
    while(!pq.empty()){
        int i = pq.top().second;
        pq.pop();
        best_price += ingred[i][4];
        best_selected.push_back(i);
        for(int j=0; j<4; j++){
            nutrients[j] += ingred[i][j];
        }
        if(nutrients[0] >= recommended[0] && nutrients[1] >= recommended[1] &&
           nutrients[2] >= recommended[2] && nutrients[3] >= recommended[3]){
            best_sum = nutrients[0] + nutrients[1] + nutrients[2] + nutrients[3];
            break;
        }
    }
}

void backtracking(int index){
    price += ingred[index][4];
    for(int i=0; i<4; i++){
        nutrients[i] += ingred[index][i];
    }
    selected.push_back(index);
    if(nutrients[0] >= recommended[0] && nutrients[1] >= recommended[1] &&
       nutrients[2] >= recommended[2] && nutrients[3] >= recommended[3]){
        bool isBest = false;
        int sum = nutrients[0] + nutrients[1] + nutrients[2] + nutrients[3];
        if(price < best_price){
            isBest = true;
        }
        else if(price == best_price){
            if(sum > best_sum){isBest = true;}
            else if(sum == best_sum){
                int k = min(selected.size(), best_selected.size());
                for(int i=0; i<k; i++){
                    if(selected[i] < best_selected[i]){
                        isBest = true;
                        break;
                    }
                    if(selected[i] > best_selected[i]){break;}
                    if(i == selected.size() - 1){isBest = true;}
                }
            }
        }
        if(isBest){
            best_price = price;
            best_sum = sum;
            best_selected = selected;
        }
    }
    else if(price + min_price[index + 1] <= best_price &&
            sums[index + 1][0] + nutrients[0] >= recommended[0] && sums[index + 1][1] + nutrients[1] >= recommended[1] &&
            sums[index + 1][2] + nutrients[2] >= recommended[2] && sums[index + 1][3] + nutrients[3] >= recommended[3]){
        backtracking(index + 1);
    }

    price -= ingred[index][4];
    for(int i=0; i<4; i++){
        nutrients[i] -= ingred[index][i];
    }
    selected.pop_back();
    if(price + min_price[index + 1] <= best_price &&
       sums[index + 1][0] + nutrients[0] >= recommended[0] && sums[index + 1][1] + nutrients[1] >= recommended[1] &&
       sums[index + 1][2] + nutrients[2] >= recommended[2] && sums[index + 1][3] + nutrients[3] >= recommended[3])
    backtracking(index + 1);
}